# -*- coding: utf-8 -*-
#
# This plugin is open source but it is NOT free software.
#
# This plugin may only be distributed to and executed on hardware which
# is licensed by Dream Multimedia GmbH.
# In other words:
# It's NOT allowed to distribute any parts of this plugin or its source code in ANY way
# to hardware which is NOT licensed by Dream Multimedia GmbH.
# It's NOT allowed to execute this plugin and its source code or even parts of it in ANY way
# on hardware which is NOT licensed by Dream Multimedia GmbH.
#
from Components.ActionMap import *
from Components.Label import Label
from Components.MenuList import MenuList
from Components.MultiContent import MultiContentEntryText, MultiContentEntryPixmap, MultiContentEntryPixmapAlphaTest
from Components.config import config
from Components.GUIComponent import GUIComponent
from enigma import ePicLoad
from Tools.LoadPixmap import LoadPixmap
from Components.Pixmap import Pixmap
from Components.AVSwitch import AVSwitch
from Screens.InfoBar import MoviePlayer
from Components.PluginComponent import plugins
from Components.Button import Button
from Screens.Screen import Screen
from Plugins.Plugin import PluginDescriptor
from twisted.web.client import getPage
from twisted.web.client import downloadPage

from Components.ServicePosition import ServicePositionGauge
from Tools.NumericalTextInput import NumericalTextInput
from Components.ConfigList import *
from Components.config import *
from Components.ConfigList import ConfigList, ConfigListScreen
from Components.config import config, ConfigSubsection, ConfigText, getConfigListEntry, ConfigSelection

from Screens.HelpMenu import HelpableScreen
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Screens.Screen import Screen

from enigma import eListboxPythonMultiContent, eListbox, gFont, RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_HALIGN_CENTER, loadPNG, RT_WRAP, eServiceReference, getDesktop, loadJPG, eTPM
from Tools.Directories import pathExists, fileExists, SCOPE_SKIN_IMAGE, resolveFilename
import sys, os, base64, re, time
from datetime import datetime
from twisted.web import client, error as weberror
from twisted.internet import reactor
from twisted.internet import defer
from urllib import urlencode
from time import strptime, mktime
import sha

# dreambox check
#------------------------------------------------------------------------------------------
etpm = eTPM()
rootkey = ['\x9f', '|', '\xe4', 'G', '\xc9', '\xb4', '\xf4', '#', '&', '\xce', '\xb3', '\xfe', '\xda', '\xc9', 'U', '`', '\xd8', '\x8c', 's', 'o', '\x90', '\x9b', '\\', 'b', '\xc0', '\x89', '\xd1', '\x8c', '\x9e', 'J', 'T', '\xc5', 'X', '\xa1', '\xb8', '\x13', '5', 'E', '\x02', '\xc9', '\xb2', '\xe6', 't', '\x89', '\xde', '\xcd', '\x9d', '\x11', '\xdd', '\xc7', '\xf4', '\xe4', '\xe4', '\xbc', '\xdb', '\x9c', '\xea', '}', '\xad', '\xda', 't', 'r', '\x9b', '\xdc', '\xbc', '\x18', '3', '\xe7', '\xaf', '|', '\xae', '\x0c', '\xe3', '\xb5', '\x84', '\x8d', '\r', '\x8d', '\x9d', '2', '\xd0', '\xce', '\xd5', 'q', '\t', '\x84', 'c', '\xa8', ')', '\x99', '\xdc', '<', '"', 'x', '\xe8', '\x87', '\x8f', '\x02', ';', 'S', 'm', '\xd5', '\xf0', '\xa3', '_', '\xb7', 'T', '\t', '\xde', '\xa7', '\xf1', '\xc9', '\xae', '\x8a', '\xd7', '\xd2', '\xcf', '\xb2', '.', '\x13', '\xfb', '\xac', 'j', '\xdf', '\xb1', '\x1d', ':', '?']

def bin2long(s):
	return reduce( lambda x,y:(x<<8L)+y, map(ord, s))

def long2bin(l):
	res = ""
	for byte in xrange(128):
		res += chr((l >> (1024 - (byte + 1) * 8)) & 0xff)
	return res

def rsa_pub1024(src, mod):
	return long2bin(pow(bin2long(src), 65537, bin2long(mod)))
	
def decrypt_block(src, mod):
	if len(src) != 128 and len(src) != 202:
		return None
	dest = rsa_pub1024(src[:128], mod)
	hash = sha.new(dest[1:107])
	if len(src) == 202:
		hash.update(src[131:192])	
	result = hash.digest()
	if result == dest[107:127]:
		return dest
	return None

def validate_cert(cert, key):
	buf = decrypt_block(cert[8:], key) 
	if buf is None:
		return None
	return buf[36:107] + cert[139:196]

def get_rnd():
	try:
		rnd = os.urandom(8)
		return rnd
	except:
		return None

#------------------------------------------------------------------------------------------

if fileExists("/usr/lib/enigma2/python/Plugins/Extensions/JobManager/plugin.pyo"):

        from Plugins.Extensions.JobManager.plugin import *
        JobManagerInstalled = True
else:
        JobManagerInstalled = False

config.plugins.omr = ConfigSubsection()
config.plugins.omr.username = ConfigText(default = "Username", fixed_size=False)
config.plugins.omr.password = ConfigText(default = "Password", fixed_size=False)

cj = {}

class myTVlist(MenuList):
        def __init__(self, list):
                MenuList.__init__(self, list, False, eListboxPythonMultiContent)
                self.l.setFont(0, gFont("Regular", 14))
                self.l.setFont(1, gFont("Regular", 16))
                self.l.setFont(2, gFont("Regular", 18))
                self.l.setFont(3, gFont("Regular", 17))
                self.l.setFont(4, gFont("Regular", 22))
                self.l.setFont(5, gFont("Regular", 24))
                self.l.setFont(6, gFont("Regular", 26))
                self.l.setFont(7, gFont("Regular", 20))

class playlist_show(GUIComponent, object):
	GUI_WIDGET = eListbox
	
	def __init__(self):
		GUIComponent.__init__(self)
		self.l = eListboxPythonMultiContent()
		self.l.setBuildFunc(self.buildList)
		self.l.setFont(0, gFont("Regular", 22))
		self.l.setFont(1, gFont("Regular", 18))
		self.l.setItemHeight(20)

	def buildList(self, entry):
		print entry
		width = self.l.getItemSize().width()
		res = [ None ]
		(artist, song, runtime, size, token) = entry
		song_icon = "/usr/lib/enigma2/python/Plugins/Extensions/omr/images/song.png"
		if fileExists(song_icon):
			png = loadPNG(song_icon)
			res.append((eListboxPythonMultiContent.TYPE_PIXMAP_ALPHATEST, 0, 0, 200, 110, png))
		res.append((eListboxPythonMultiContent.TYPE_TEXT, 50, 0, 270, 20, 1, RT_HALIGN_LEFT, artist))
		res.append((eListboxPythonMultiContent.TYPE_TEXT, 320, 0, 330, 20, 1, RT_HALIGN_LEFT, song))
		res.append((eListboxPythonMultiContent.TYPE_TEXT, 650, 0, 50, 20, 0, RT_HALIGN_LEFT, runtime))
		res.append((eListboxPythonMultiContent.TYPE_TEXT, 700, 0, 80, 20, 1, RT_HALIGN_RIGHT, size))
		return res

	def getCurrent(self):
		cur = self.l.getCurrentSelection()
		return cur and cur[0]

	def postWidgetCreate(self, instance):
		instance.setContent(self.l)
		self.instance.setWrapAround(True)

	def preWidgetRemove(self, instance):
		instance.setContent(None)

	def setList(self, list):
		self.l.setList(list)

	def moveToIndex(self, idx):
		self.instance.moveSelectionTo(idx)
		
class omr_setup(Screen, ConfigListScreen):
	skin = """
		<screen position="center,center" size="450,80" title="Setup">
			<ePixmap position="15,4" size="16,16" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/omr/images/username.png" alphatest="blend" />
			<ePixmap position="15,29" size="16,16" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/omr/images/password.png" alphatest="blend" />
			<widget name="config" position="50,0" size="400,50" scrollbarMode="showOnDemand" />
		</screen>"""		

	def __init__(self, session, plugin_path):
		Screen.__init__(self, session)
		self.plugin_path = plugin_path
		self.skin_path = plugin_path
		self.session = session
		
		self.list = []
		ConfigListScreen.__init__(self, self.list)
		
		self.list.append(getConfigListEntry("User:", config.plugins.omr.username))
		self.list.append(getConfigListEntry("Pass:", config.plugins.omr.password))

		self["config"].setList(self.list)

		self["setupActions"] = ActionMap(["SetupActions"],
                {
                        "ok":           self.saveConfig,
                        "cancel":       self.exit,
                }, -1)

	def saveConfig(self):
		print "save"
		for x in self["config"].list:
			x[1].save()
		self.close("True")
	
	def exit(self):
		print "closen"
		self.close("False")
	
class omr(Screen, ConfigListScreen, NumericalTextInput):
	if getDesktop(0).size().width() == 1280:
		skin = """
			<screen position="center,center" size="800,485" title="OMR (Online Music Recorder) Streamer v0.5">
				<widget name="myTVmenulist" position="0,5" size="790,402" transparent="1" scrollbarMode="showOnDemand" />
				<widget name="info" position="50,420" size="550,24" zPosition="0" font="Regular;22" transparent="1" foregroundColor="yellow" />
				<ePixmap position="15,425" size="16,16" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/omr/images/info.png" alphatest="blend" />
				<widget name="ButtonRed" position="48,474" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/omr/images/red.png" zPosition="10" size="140,8" transparent="1" alphatest="on" />
				<widget name="TextRed" position="48,450" size="140,24" valign="center" halign="center" zPosition="10" font="Regular;18" transparent="1" />
				<widget name="ButtonGreen" position="236,474" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/omr/images/green.png" zPosition="10" size="140,8" transparent="1" alphatest="on" />
				<widget name="TextGreen" position="236,450" size="140,24" valign="center" halign="center" zPosition="10" font="Regular;18" transparent="1" />
				<widget name="ButtonYellow" position="424,474" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/omr/images/yellow.png" zPosition="10" size="140,8" transparent="1" alphatest="on" />
				<widget name="TextYellow" position="424,450" size="140,24" valign="center" halign="center" zPosition="10" font="Regular;18" transparent="1" />
				<widget name="ButtonBlue" position="612,474" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/omr/images/blue.png" zPosition="10" size="140,8" transparent="1" alphatest="on" />
				<widget name="TextBlue" position="612,450" size="140,24" valign="center" halign="center" zPosition="10" font="Regular;18" transparent="1" />
				<widget name="ButtonPlay" position="550,424" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/omr/images/play.png" zPosition="10" size="16,16" transparent="1" alphatest="on" />
				<widget source="session.CurrentService" render="Label" position="690,420" size="100,20" zPosition="1" font="Regular;20" halign="left" foregroundColor="#999999" transparent="1" >
						<convert type="ServicePosition">Length,ShowHours</convert>
				</widget>
				<widget source="session.CurrentService" render="Label" position="600,420" size="100,22" zPosition="1" font="Regular;22" halign="left" foregroundColor="#fcc000" transparent="1" >
						<convert type="ServicePosition">Position,ShowHours</convert>
				</widget>
			</screen>"""
				
	def __init__(self, session, plugin_path):
		Screen.__init__(self, session)
		self.plugin_path = plugin_path
		self.skin_path = plugin_path
		self.session = session

		NumericalTextInput.__init__(self)
		self.setUseableChars(u'1234567890abcdefghijklmnopqrstuvwxyz')

		self["info"] = Label("")

		self["ButtonPlay"] = Pixmap()
		self["ButtonPlay"].hide()
		self["ButtonRed"] = Pixmap()
		self["TextRed"] = Label("Download")
		self["ButtonGreen"] = Pixmap()
		self["TextGreen"] = Label("Login")
		self["ButtonYellow"] = Pixmap()
		self["TextYellow"] = Label("Add to Playlist")
		self["ButtonBlue"] = Pixmap()
		self["TextBlue"] = Label("Refresh List")

		#self.myTVmenulist = []
		#self.myTVmenulist = playlist_show()
		self["myTVmenulist"] = playlist_show()
		#self["myTVmenulist"] = myTVlist([])
		#self["myTVmenulist"].selectionEnabled(0)
		
		self.username = config.plugins.omr.username.value
		self.password = config.plugins.omr.password.value

		self.lastservice = session.nav.getCurrentlyPlayingServiceReference()

		self.ok_info = False
		self.playORdownload = False
		self.loggen = False

		self["shortcuts"] = NumberActionMap(["ShortcutActions", "WizardActions", "NumberActions", "InputActions", "InputAsciiActions", "KeyboardInputActions" ],
		{
			"gotAsciiCode": self.keyGotAscii,
			"1": self.keyNumberGlobal,
			"2": self.keyNumberGlobal,
			"3": self.keyNumberGlobal,
			"4": self.keyNumberGlobal,
			"5": self.keyNumberGlobal,
			"6": self.keyNumberGlobal,
			"7": self.keyNumberGlobal,
			"8": self.keyNumberGlobal,
			"9": self.keyNumberGlobal,
			"0": self.keyNumberGlobal
		}, -1)		
		
		self["OkCancelActions"] = HelpableActionMap(self, "OkCancelActions",
		{
			"cancel":	self.exit,
			"ok":		self.ok,
		}, -1)
		
		self["InfobarActions"] = HelpableActionMap(self, "InfobarActions",
		{
			"showMovies":	self.jobix,
		}, -1)

		self["ColorActions"] = HelpableActionMap(self, "ColorActions",
		{
			"red":		self.downi,
			"blue":		self.make_list,
			"green":	self.login,
		}, -1)

                self["EPGSelectActions"] = HelpableActionMap(self, "EPGSelectActions",
                {
                        "input_date_time":	self.omronfig,
                }, -1)

                self["MoviePlayerActions"] = HelpableActionMap(self, "MoviePlayerActions",
                {
                        "leavePlayer":      self.leavePlayer,
                }, -1)

		cj = {}

		rcinput = eRCInput.getInstance()
		rcinput.setKeyboardMode(rcinput.kmAscii)

		self.login()

	def leavePlayer(self):
		print "back....."
		self.session.nav.stopService()
		self["ButtonPlay"].hide()
		self.session.nav.playService(self.lastservice)

	def omronfig(self):
		self.session.openWithCallback(self.danach, omr_setup, plugin_path)

	def danach(self, data):
		print data
		if data == "True":
			print "menu true"
                	self.username = config.plugins.omr.username.value
                	self.password = config.plugins.omr.password.value
			print self.username
			print self.password
			self.login()
		else:
			print "menu false"

	def keyNumberGlobal(self, val):
		key = self.getKey(val)
		if key is not None:
			keyvalue = key.encode("utf-8")
			if len(keyvalue) == 1:
				self.setNextIdx(keyvalue[0])
		
	def keyGotAscii(self):
		keyvalue = unichr(getPrevAsciiCode()).encode("utf-8")
		if len(keyvalue) == 1:
			self.setNextIdx(keyvalue[0])
		
	def setNextIdx(self,char):
		if char in ("0", "1", "a"):
			self["myTVmenulist"].moveToIndex(0)
		else:
			idx = self.getNextIdx(char)
			if idx and idx <= len(self.myTVmenulist):
				self["myTVmenulist"].moveToIndex(idx)

	def getNextIdx(self,char):
		idx = 0
		for i in self.myTVmenulist:
			if i[0][0][0].lower() == char:
				return idx
			idx += 1

	def downi(self):
		if JobManagerInstalled:
			self.playORdownload = True
			self.ok()

	def download_now(self, link):
		self.playORdownload = False
		print link
		self.filename = re.findall('en/(.*?.mp3)', link, re.S)
		print self.filename
		self.currentDownload = ""
		self.currentDownload = jm.addJobToList(link, self.filename[0])
		jm.startDownload(self.currentDownload)
		message = self.session.open(MessageBox, ("Download started, Please check progress in JobManager with PVR Button."), MessageBox.TYPE_INFO,timeout=5)

	def jobix(self):
		self.session.open(JobManagerFrontEnd)

	def login(self):
		self["info"].setText("Try to login..")
		url = 'http://www.onlinemusicrecorder.com/login.php?e=%s&p=%s' % (self.username, self.password)
		client.getPage(url, method='POST', cookies=cj, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.check_login).addErrback(self.errorload)

	def check_login(self, data):
		print "check_login"
		#self.myTVmenulist = []
		if re.match('.*?You are logged in', data, re.S):
			print "yes"
			self["info"].setText("Welcome %s" % self.username)
			self.loggen = True
			self.show_list()
		else:
			print "no"
			self.loggen = False
			self["info"].setText("Login fehlgeschlagen, Press MENU and set your Username/Password.")

	def show_list(self):
		print "zeige an"
		self.count = 0
		if fileExists("/usr/lib/enigma2/python/Plugins/Extensions/omr/list"):
			inp = open ("/usr/lib/enigma2/python/Plugins/Extensions/omr/list","r")
			self.myTVmenulist = []
			#self.myTVmenulist.append(self.show_list_gui("Artist", "Title", "Time", "Size", "no_token"))
			self.myTVmenulist.append((("Artist", "Title", "Time", "Size", "no_token"),))
			for lines in inp.readlines():
				line = re.findall('"(.*?)" "(.*?)" "(.*?)" "(.*?)" "(.*?)"', lines, re.S)
				(artist, song, runtime, size, token) = line[0]
				#self.myTVmenulist.append(self.show_list_gui(artist, song, runtime, size, token))
				#self["myTVmenulist"].l.setList(self.myTVmenulist)
				#self["myTVmenulist"].l.setItemHeight(20)
				self.myTVmenulist.append(((artist, song, runtime, size, token),))
			self["myTVmenulist"].setList(self.myTVmenulist)
			inp.close()
			inp = open ("/usr/lib/enigma2/python/Plugins/Extensions/omr/list","r")
			self.count = len(inp.readlines())
			inp.close()
			if self.count == 0:
				self["info"].setText("Press Blue.. for building your song list.")
			else:
				self["info"].setText("%s Songs ready to download." % self.count)
				self.ok_info = True
		else:
			print "file nicht da."

	def show_list_gui(self, artist, song, runtime, size, token):
		res = [(artist, song, runtime, size, token)]
		song_icon = "/usr/lib/enigma2/python/Plugins/Extensions/omr/images/song.png"
		if fileExists(song_icon):
			res.append(MultiContentEntryPixmapAlphaTest(pos=(15, 0), size=(16, 16), png=loadPNG(song_icon)))		
		res.append(MultiContentEntryText(pos=(50, 0), size=(270, 20), font=2, text=artist, flags=RT_HALIGN_LEFT))
		res.append(MultiContentEntryText(pos=(320, 0), size=(330, 20), font=2, text=song, flags=RT_HALIGN_LEFT))
		res.append(MultiContentEntryText(pos=(650, 0), size=(50, 20), font=2, text=runtime, flags=RT_HALIGN_LEFT))
		res.append(MultiContentEntryText(pos=(700, 0), size=(80, 20), font=2, text=size, flags=RT_HALIGN_LEFT))
		return res

	def make_list(self):
		self.counter = 0
		create = open("/usr/lib/enigma2/python/Plugins/Extensions/omr/list", "a")
		create.truncate(0)
		create.close()
		url = "http://www.onlinemusicrecorder.com/recordings.php"
                getPage(url, method='GET', cookies=cj, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.get_pages).addErrback(self.errorload)

	def get_pages(self, data):
		print "drin"
		pages = re.findall("<option  value='([0-9]*)'>", data, re.S)
		self.page_count = len(pages)
		pages_list = []
		for each in pages:
			url = "http://www.onlinemusicrecorder.com/recordings.php?start=%s" % each
			pages_list.append((url))

		ds = defer.DeferredSemaphore(tokens=1)
		downloads = [ds.run(self.download2,item).addCallback(self.create_list).addErrback(self.errorload) for item in pages_list]
		finished = defer.DeferredList(downloads).addErrback(self.errorload)

	def download2(self, url):
		return client.getPage(url, cookies=cj, headers={'Content-Type':'application/x-www-form-urlencoded'})		

	def create_list(self, data):
		ok = re.findall("recordings.php.a=(.*?)'.*?recordings.php.t=(.*?)'.*?recordings.php.l.*?>(.*?)<.*?recordings.php.s.*?>(.*?)<.*?get_omr.php.id=(.*?)'", data, re.S)
		create = open("/usr/lib/enigma2/python/Plugins/Extensions/omr/list", "a")
		for each in ok:
			(artist, song, runtime, size, token) = each
			create.write('"%s" "%s" "%s" "%s" "%s"\n' % (artist, song, runtime, size, token))
		create.close()
		self.counter += 1
		self["info"].setText("Loading Page %s/%s" % (self.counter, self.page_count))
		if int(self.counter) == int(self.page_count):
			self["info"].setText("Reload Song list.")
			self.login()

	def errorload(self, error):
		print "[OMR]:", error
		
	def ok(self):
		if self.ok_info:
			item = self["myTVmenulist"].getCurrent()
			token = item[4]
			print token
			if not token == "no_token":
				url = "http://www.onlinemusicrecorder.com/get_omr.php?id=%s" % token
				getPage(url, method='GET', cookies=cj, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.download).addErrback(self.errorload)

	def download(self, data):
		get_file = re.findall("<a href='(.*?)'>", data, re.S)
		if get_file:
			if not self.playORdownload:
				print get_file[0]
				if self.session.nav:
					print "gestoppppttt.."
					self.session.nav.stopService()
				sref = eServiceReference(0x1001, 0, get_file[0])
				self.session.nav.playService(sref)
				self["ButtonPlay"].show()
			else:
				self.download_now(get_file[0])
		else:
			self["info"].setText("Download Fehler !")	

	def exit(self):
		self.session.nav.playService(self.lastservice)
		self.close()

def checkDream():
	l2 = False
	l2cert = etpm.getCert(eTPM.TPMD_DT_LEVEL2_CERT)
	if l2cert is None:
		print "l2cert not found"
		return False
	
	l2key = validate_cert(l2cert, rootkey)
	if l2key is None:
		print "l2cert invalid"
		return False
	l2 = True
	return True
	
def main(session, **kwargs):
	if checkDream():
		session.open(omr, plugin_path)
	else: 
		session.open(MessageBox, "No Orginal Dreambox - No Support", type = MessageBox.TYPE_INFO,timeout = 20 )

def Plugins(path, **kwargs):
	global plugin_path
	plugin_path = path
	return [
		PluginDescriptor(name="OMR Streamer", description="Online Music Recorder Streamer and Downloader", where = [PluginDescriptor.WHERE_EXTENSIONSMENU], fnc=main),
		PluginDescriptor(name="OMR Stream", description="Online Music Recorder Streamer and Downloader", where = [PluginDescriptor.WHERE_PLUGINMENU], fnc=main)
		]
